#include <stdio.h>
#include <string.h>
#include <ctype.h>


typedef struct Node {
	unsigned short	ntyp;	/* node type */
        char    *txt;		/* text - value attribute */
        void   *nstr;           /* node structure */
	struct Node	*lft, *rgt;   /* children in the parse tree */
} Node;

typedef Node * Nodeptr;

typedef struct SyStruct {
  Node *types;
  Node *signals;
  Node *buffers;
  Node *processes;
} SyStruct;

typedef struct SigStruct {
  int eff_nr_arg; /* effective number of arguments */
} SigStruct;

typedef struct VarStruct {
  Node *vtyp;
  Node *dflt; 
} VarStruct;

typedef struct BuffStruct {
  Node *signals;
  int slotsize;
} BuffStruct;

typedef struct StateStruct {
  Node *options;
  Node *discards;
  Node *saves; /* !? */
} StateStruct;

typedef struct InputStruct {
  Node *signal; /* gate, if SYNC */
  Node *sigexpr;
  Node *frombuff; /* offert, if SYNC */ 
  Node *guard;
  Node *offert;  
} InputStruct;

typedef struct TransStruct {
  Node *source; 
  Node *optionset;
  Node *guard;
  Node *input;
  Node *body;
  Node *target;
} TransStruct;

typedef struct ProcStruct {
  Node *buffer;
  Node *vars;
  Node *states;
  Node *trans;
} ProcStruct;

typedef struct FilterActionStruct {
  Node *signals;
  Node *buffer;
  Node *guard;
} FilterActionStruct;

#define YYSTYPE Nodeptr

#define ZN (Node *)0
#define ZS (void *)0 /* !! */
#define ZC ""

#define IF_ERROR(msg){\
  fprintf(stderr,"%s ! (abort)\n", msg);\
  exit(1);\
  }

static char IfParserFilename[256];                          /* input file */
static char IfParserMessage[256];                       /* message buffer */

/* Function prototype definitions */

/* main.c */
char *emalloc(int);
Node *nn(int, char *, void *, Node *, Node *);
Node *insertl(Node *, Node *);
void replace_any(Node *);

/* trans.c */
void translate();
void headings();
void types();
void signals();
int type_size(Node *);
Node *find_var_type(Node *, Node *);
int enum_const(Node *);
Node *find_symbol(Node *, Node *);
void buffers();
char *BuffType(Node *);
void processes();
void vars(Node *, Node *);
int is_timer_name(char *, Node *);
void PrintExpr(Node *, Node *);
void body(Node *, Node *);
void discards(Node *, Node *, Node *);


