/* 
-----------------------

-----------------------
*/

#include "if2pml.h"
#include "y.tab.h"

extern FILE *yyin, *yyout;

/*
-----------------------------------------------------------------------
Main routine
-----------------------------------------------------------------------
*/

void main(int argc, char* argv[]){

  char OutFilename[256];

  if (argc != 2){
    fprintf(stderr,"usage: %s <filename>\n",argv[0]);
    exit(1);
  }
  
  /* sprintf(IfParserFilename, "%s", argv[0]); */
  strcpy(IfParserFilename, argv[0]);
   
  /* open the input  file */
  if ( (yyin = fopen(argv[1], "r")) == NULL){
    sprintf(IfParserMessage, "can't open file %s", argv[1]);
    IF_ERROR(IfParserMessage);
  } 

  sprintf(OutFilename, "%s.pml", argv[1]);

  /* parsing */
  yyparse();

  /* translation */
  translate(OutFilename);

}

char *
emalloc(int n)
{	char *tmp;

	if (!(tmp = (char *) malloc(n)))
		yyerror("not enough memory\n");
	memset(tmp, 0, n);
	return tmp;
}

Node *
nn(int ntyp, char *txt, void *nstr, Node *lft, Node *rgt)
{
  Node *n = (Node *) emalloc(sizeof(Node));
  n->ntyp = ntyp;
  n->txt = (char *) emalloc(strlen(txt)+1);
  strcpy(n->txt,txt);
  n->nstr = nstr;
  n->lft = lft;
  n->rgt = rgt;
  return n;
}

/* insert at the end of the list */
Node *insertl(Node *list, Node *n)
{
  Node *p;
  if (!list) 
    {list = n;}
  else
    {
      for(p = list; p->rgt; p = p->rgt);
      p->rgt = n;
    };
  return list;
}

/* replace any's in output statements */
void replace_any(Node *n)
{
  Node *p;
  for (p = n; p; p = p->rgt)
    if (p->ntyp == ANY) 
      strcpy(p->txt, "any_snd");
}






